from openerp.osv import osv, fields
from openerp.tools.translate import _
import openerp.addons


class crossovered_budget_lines_gl(osv.osv):
    _inherit = "crossovered.budget.lines"
    _name = "crossovered.budget.lines"
    
    def _prac_amt(self, cr, uid, ids, context=None):
        res = {}
        result = 0.0
        result_gl = 0.0
        result_gl_cre= 0.0
        result_gl_deb= 0.0
        if context is None: 
            context = {}
        for line in self.browse(cr, uid, ids, context=context):
            acc_ids = [x.id for x in line.general_budget_id.account_ids]
            #if not acc_ids:                
                #raise osv.except_osv(_('Error!'),_("The Budget '%s' has no accounts!") % str(line.general_budget_id.name))
            date_to = line.date_to
            date_from = line.date_from
            if context.has_key('wizard_date_from'):
                date_from = context['wizard_date_from']
            if context.has_key('wizard_date_to'):
                date_to = context['wizard_date_to']
            if line.analytic_account_id.id:
                cr.execute("SELECT SUM(amount) FROM account_analytic_line WHERE account_id=%s AND (date "
                       "between to_date(%s,'yyyy-mm-dd') AND to_date(%s,'yyyy-mm-dd'))", (line.analytic_account_id.id, date_from, date_to,))
                result = cr.fetchone()[0]
                
            if acc_ids:
                for conto in acc_ids:           
                    cr.execute("SELECT SUM(credit) from account_move_line WHERE account_id=%s AND (date "
                       "between to_date(%s,'yyyy-mm-dd') AND to_date(%s,'yyyy-mm-dd'))",(conto, date_from, date_to))    
                    result_gl_cre = cr.fetchone()[0]
                    if result_gl_cre is not None:
                        result_gl = result_gl - result_gl_cre
                        
                    cr.execute("SELECT SUM(debit) from account_move_line WHERE account_id=%s AND (date "
                       "between to_date(%s,'yyyy-mm-dd') AND to_date(%s,'yyyy-mm-dd'))",(conto, date_from, date_to))    
                    result_gl_deb = cr.fetchone()[0]
                    if result_gl_deb is not None:
                        result_gl = result_gl + result_gl_deb
                                    
            if result is None:
                result = 0.00

            res[line.id] = float.__abs__(result) + float.__abs__(result_gl)           
        return res
    
crossovered_budget_lines_gl()